.TH JD 1 "15 June 1996" "DOS network application"
.SH NAME
jd \- DOS client for Direct protocol mode in PPRD
.SH SYNOPSIS
.B jd
[\fB-P\fIn\fR] [\fB-H\fIhost\fR] [\fB-B\fIportbase\fR] [\fIfile\fR]
.SH DESCRIPTION
.I jd
is a client programs that print files to a PPRD server in Direct
protocol mode.  The job is sent as a TCP data stream ended by closing
the connection.  The advantage of this protocol is that the size of the
job does not need to be known in advance, which could be used to
advantage in a print redirector. It is more efficient because there are
fewer transactions than in the LPD protocol.
.LP
.I jd
prints the specified file or standard input if none is specified.
.SH INSTALLATION
.I pprd
requires:  a network interface card and a FTP Software specification
Packet Driver for it, and a valid WATTCP configuration file,
WATTCP.CFG. WATTCP.CFG must be in the current directory or in the
directory where
.I jd.exe
is installed, or pointed to by the WATTCP_CFG environment variable.
.SH OPTIONS
.TP
.BI -P n
print to printer
.I n
(0 = LPT1, 1 = LPT2, 2 = LPT3, default 0)
.TP
.BI -B p
base of direct protocol ports is p (default 9100)
.TP
.BI -H host
send to
.I host
(default
.BR printer ).
.SH "CONFIGURATION FILE SETTINGS"
The following variables can be assigned to in the WATTCP.CFG file:
PRINTERHOST, PORTBASE, PRINTERNUM. They have the same effect as the
\fB\-H\fP, \fB\-B\fP, and \fB\-P\fP flags.  The command line flags
override the configuration file settings.
.SH "SEE ALSO (on Unix)"
lpr(1), lpq(1), lpc(8), lpd(8)
.SH FILES
WATTCP.CFG
.SH DIAGNOSTICS
Hopefully self explanatory.
.SH BUGS
There is a bug in WATTCP's handling of a half close. The WATTCP
code in server does a full close of its end when it receives a half
close. As a result,
.I jd
cannot know when the job has been finished.
If you run jd from a within a spooling system, you will need to add
some code to
.I jd
to wait until it can connect to the server again at the end of
of a job, before returning to the caller, otherwise the
next job may fail due to being busy with the current job.
Jd.pl contains this hack but jd.c doesn't.
.SH COPYRIGHT
.I jd
is under the Artistic License, which allows you to freely distribute
the program provided the sources accompany, or are made available on
request. See Artistic for details.
.SH AUTHOR
Ken Yap (ken@syd.dit.csiro.au)
.SH DATE
June 1996
